-
  name: Start Here
  documents:
    -
      name: Getting Started with Rails
      url: getting_started.html
      description: Everything you need to know to install Rails and create your first application.
-
  name: Models
  documents:
    -
      name: Active Record Basics
      url: active_record_basics.html
      description: This guide will get you started with models, persistence to database and the Active Record pattern and library.
    -
      name: Active Record Migrations
      url: active_record_migrations.html
      description: This guide covers how you can use Active Record migrations to alter your database in a structured and organized manner.
    -
      name: Active Record Validations
      url: active_record_validations.html
      description: This guide covers how you can use Active Record validations
    -
      name: Active Record Callbacks
      url: active_record_callbacks.html
      description: This guide covers how you can use Active Record callbacks.
    -
      name: Active Record Associations
      url: association_basics.html
      description: This guide covers all the associations provided by Active Record.
    -
      name: Active Record Query Interface
      url: active_record_querying.html
      description: This guide covers the database query interface provided by Active Record.
    -
      name: Active Model basics
      url: active_model_basics.html
      description: This guide covers the use of model classes without Active Record.
      work_in_progress: true
-
  name: Views
  documents:
    -
      name: Action View Overview
      url: action_view_overview.html
      description: This guide provides an introduction to Action View and introduces a few of the more common view helpers.
      work_in_progress: true
    -
      name: Layouts and Rendering in Rails
      url: layouts_and_rendering.html
      description: This guide covers the basic layout features of Action Controller and Action View, including rendering and redirecting, using content_for blocks, and working with partials.
    -
      name: Action View Form Helpers
      url: form_helpers.html
      description: Guide to using built-in Form helpers.
-
  name: Controllers
  documents:
    -
      name: Action Controller Overview
      url: action_controller_overview.html
      description: This guide covers how controllers work and how they fit into the request cycle in your application. It includes sessions, filters, and cookies, data streaming, and dealing with exceptions raised by a request, among other topics.
    -
      name: Rails Routing from the Outside In
      url: routing.html
      description: This guide covers the user-facing features of Rails routing. If you want to understand how to use routing in your own Rails applications, start here.
-
  name: Digging Deeper
  documents:
    -
      name: Active Support Core Extensions
      url: active_support_core_extensions.html
      description: This guide documents the Ruby core extensions defined in Active Support.
    -
      name: Rails Internationalization API
      url: i18n.html
      description: This guide covers how to add internationalization to your applications. Your application will be able to translate content to different languages, change pluralization rules, use correct date formats for each country and so on.
    -
      name: Action Mailer Basics
      url: action_mailer_basics.html
      description: This guide describes how to use Action Mailer to send and receive emails.
    -
      name: Active Job Basics
      url: active_job_basics.html
      description: This guide provides you with all you need to get started in creating, enqueueing and executing background jobs.
    -
      name: Testing Rails Applications
      url: testing.html
      work_in_progress: true
      description: This is a rather comprehensive guide to doing both unit and functional tests in Rails. It covers everything from 'What is a test?' to the testing APIs. Enjoy.
    -
      name: Securing Rails Applications
      url: security.html
      description: This guide describes common security problems in web applications and how to avoid them with Rails.
    -
      name: Debugging Rails Applications
      url: debugging_rails_applications.html
      description: This guide describes how to debug Rails applications. It covers the different ways of achieving this and how to understand what is happening "behind the scenes" of your code.
    -
      name: Configuring Rails Applications
      url: configuring.html
      description: This guide covers the basic configuration settings for a Rails application.
    -
      name: Rails Command Line Tools and Rake Tasks
      url: command_line.html
      description: This guide covers the command line tools and rake tasks provided by Rails.
    -
      name: Asset Pipeline
      url: asset_pipeline.html
      description: This guide documents the asset pipeline.
    -
      name: Working with JavaScript in Rails
      url: working_with_javascript_in_rails.html
      description: This guide covers the built-in Ajax/JavaScript functionality of Rails.
    -
      name: Getting Started with Engines
      url: engines.html
      description: This guide explains how to write a mountable engine.
      work_in_progress: true
    -
      name: The Rails Initialization Process
      work_in_progress: true
      url: initialization.html
      description: This guide explains the internals of the Rails initialization process as of Rails 4
    -
      name: Autoloading and Reloading Constants
      url: autoloading_and_reloading_constants.html
      description: This guide documents how autoloading and reloading constants work.
-
  name: Extending Rails
  documents:
    -
      name: The Basics of Creating Rails Plugins
      work_in_progress: true
      url: plugins.html
      description: This guide covers how to build a plugin to extend the functionality of Rails.
    -
      name: Rails on Rack
      url: rails_on_rack.html
      description: This guide covers Rails integration with Rack and interfacing with other Rack components.
    -
      name: Creating and Customizing Rails Generators
      url: generators.html
      description: This guide covers the process of adding a brand new generator to your extension or providing an alternative to an element of a built-in Rails generator (such as providing alternative test stubs for the scaffold generator).
-
  name: Contributing to Ruby on Rails
  documents:
    -
      name: Contributing to Ruby on Rails
      url: contributing_to_ruby_on_rails.html
      description: Rails is not 'somebody else's framework.' This guide covers a variety of ways that you can get involved in the ongoing development of Rails.
    -
      name: API Documentation Guidelines
      url: api_documentation_guidelines.html
      description: This guide documents the Ruby on Rails API documentation guidelines.
    -
      name: Ruby on Rails Guides Guidelines
      url: ruby_on_rails_guides_guidelines.html
      description: This guide documents the Ruby on Rails guides guidelines.
-
  name: Maintenance Policy
  documents:
    -
      name: Maintenance Policy
      url: maintenance_policy.html
      description: What versions of Ruby on Rails are currently supported, and when to expect new versions.
-
  name: Release Notes
  documents:
    -
      name: Upgrading Ruby on Rails
      url: upgrading_ruby_on_rails.html
      description: This guide helps in upgrading applications to latest Ruby on Rails versions.
    -
      name: Ruby on Rails 4.2 Release Notes
      url: 4_2_release_notes.html
      description: Release notes for Rails 4.2.
    -
      name: Ruby on Rails 4.1 Release Notes
      url: 4_1_release_notes.html
      description: Release notes for Rails 4.1.
    -
      name: Ruby on Rails 4.0 Release Notes
      url: 4_0_release_notes.html
      description: Release notes for Rails 4.0.
    -
      name: Ruby on Rails 3.2 Release Notes
      url: 3_2_release_notes.html
      description: Release notes for Rails 3.2.
    -
      name: Ruby on Rails 3.1 Release Notes
      url: 3_1_release_notes.html
      description: Release notes for Rails 3.1.
    -
      name: Ruby on Rails 3.0 Release Notes
      url: 3_0_release_notes.html
      description: Release notes for Rails 3.0.
    -
      name: Ruby on Rails 2.3 Release Notes
      url: 2_3_release_notes.html
      description: Release notes for Rails 2.3.
    -
      name: Ruby on Rails 2.2 Release Notes
      url: 2_2_release_notes.html
      description: Release notes for Rails 2.2.
